package main

import (
	"context"
	triplepb "dubbo-test/api"
	"dubbo.apache.org/dubbo-go/v3/common/logger"
	"dubbo.apache.org/dubbo-go/v3/config"
	_ "dubbo.apache.org/dubbo-go/v3/imports"
	tripleConstant "github.com/dubbogo/triple/pkg/common/constant"
)

var userServiceProvider = new(triplepb.UserServiceClientImpl)

var accountServiceProvider = new(triplepb.AccountServiceClientImpl)

func init() {
	config.SetConsumerService(userServiceProvider)
	config.SetConsumerService(accountServiceProvider)
}

func main() {
	if err := config.Load(); err != nil {
		panic(err)
	}

	unary()
	unary()
	unary()
	unary()
	unaryAccount()
	unaryAccount()
	unaryAccount()
	unaryAccount()
	unaryAccount()
}

func unary() {
	logger.Infof(">>>>> Dubbo-go client is about to call to GetUser")

	//ctx := context.Background()
	//ctx = context.WithValue(ctx, tripleConstant.TripleCtxKey(tripleConstant.TripleRequestID), "triple-request-id-demo")

	req := triplepb.UserRequest{
		Name: "张三",
		User: &triplepb.UserEntity{
			Username: "张三",
			Pwd:      "123456",
		},
	}
	user, err := userServiceProvider.GetUser(context.TODO(), &req)
	if err != nil {
		//panic(err)
	}

	logger.Infof("Receive user = %+v\n", user)
}

func unaryAccount() {
	logger.Infof(">>>>> Dubbo-go client is about to call to GetAccount")

	ctx := context.Background()
	ctx = context.WithValue(ctx, tripleConstant.TripleCtxKey(tripleConstant.TripleRequestID), "triple-request-id-demo")

	req := triplepb.AccountRequest{
		Id: 66,
	}
	account, err := accountServiceProvider.GetAccount(ctx, &req)
	if err != nil {
		//panic(err)
	}

	logger.Infof("Receive account = %+v\n", account)
}
