package pkg

import (
	"context"
	triplepb "dubbo-test/api"
	"dubbo.apache.org/dubbo-go/v3/common/logger"
)

type UserServiceProvider struct {
	triplepb.UnimplementedUserServiceServer
}

func (s *UserServiceProvider) SayHello(ctx context.Context, request *triplepb.UserRequest) (*triplepb.UserReply, error) {
	return &triplepb.UserReply{
		Message: "GO Reply HELLO" + request.Name,
	}, nil
}

func (s *UserServiceProvider) GetUser(ctx context.Context, request *triplepb.UserRequest) (*triplepb.UserEntity, error) {
	logger.Infof("Dubbo3 GetUser received userName : %s\n", request.GetUser().GetUsername())
	return &triplepb.UserEntity{
		Username: "GO NAME : " + request.GetUser().GetUsername(),
		Pwd:      request.GetUser().GetPwd() + "123123",
	}, nil
}
